

#include "generalization.h"




// 1: true
// 0: false
int isAlphaKAnonymity(data *dataSet, summary *synopsis, configure *config)
{
	int i;

	int noOfSen;

	int totalNo;

	//noOfSen = 0;

	// sorting according to the list of attributes in config->senAttrNo
	//data_sort(dataSet, config->noOfSenAttr, config->senAttrNo);
	//summary_sort(synopsis, config->noOfSenAttr, config->senAttrNo);

	// Assume only one sensitve attribute
	//int summary_getNoOfSen(data *dataSet, summary *synopsis, int noOfDim, int *dimNo)
	noOfSen = summary_getNoOfSen(dataSet, synopsis, config->noOfSenAttr, config->senAttrNo);

	// can be replaced with totalNo = dataSet->noOfTuple
	totalNo = 0;
	for (i = 0; i < synopsis->noOfGroup; i++)
	{
		totalNo += synopsis->grouping[i].noOfMember;
	}

	if (noOfSen/(double)totalNo <= config->alpha)
	{
		return 1;
	}
	else
	{
		return 0;
	}
	

}


void generalizeDimension(dimension *dim, generalizedLevelTable *genLevelTable)
{
	int i;

	int noOfPoss;


	noOfPoss = genLevelTable->noOfPoss;

	for (i = 0; i < noOfPoss; i++)
	{
		if (genLevelTable->gen[i].bottomValue == dim->value)
		{
			// generalize
			dim->value = genLevelTable->gen[i].topValue;
			dim->level = genLevelTable->gen[i].topLevel;

			break;
		}
	}
}

void generalizeEquivalenceTuple(equivalenceTuple *eqTuple, int attrNo, generalizedLevelTable *genLevelTable)
{
	dimension *dim;
	
	dim = &(eqTuple->content[attrNo]);
	generalizeDimension(dim, genLevelTable);
}

void generalizeEqClass(equivalenceClass *eqClass, int attrNo, configure *conf, generalizedAllTable *genAllTable)
{
	int i;

	int noOfDim;
	int genBottomLevel;

	equivalenceTuple *eqTuple;
	equivalenceTuple *eqOne;


	generalizedDimTable *genDimTable;
	generalizedLevelTable *genLevelTable;

	noOfDim = conf->noOfDim;

	genDimTable = &(genAllTable->genDimTable[attrNo]);

	eqTuple = (equivalenceTuple *) eqClass->eqClass;

	if (eqClass->noOfEqClass > 0)
	{
		genBottomLevel = eqTuple[0].content[attrNo].level;
		genLevelTable = &(genDimTable->gen[genBottomLevel]);

		for (i = 0; i < eqClass->noOfEqClass; i++)
		{
			eqOne = &(eqTuple[i]);
			generalizeEquivalenceTuple(eqOne, attrNo, genLevelTable);
		}
	}
	else
	{
		// do nothing
	}
}


void calculateSensitiveCount(equivalenceClass *eqClass, configure *conf, int *senCount, int *totalCount)
{
	int i;

	int inSenCount;
	int inTotalCount;

	equivalenceTuple **eqTuple;
	equivalenceTuple *eqOne;

	eqTuple = eqClass->eqClass;

	inSenCount = 0;
	inTotalCount = 0;
	for (i = 0; i < eqClass->noOfEqClass; i++)
	{
		//eqOne = &(eqTuple[i]);
		eqOne = eqTuple[i];

		inTotalCount += eqOne->noOfMember;
		inSenCount += eqOne->noOfSen;
	}

	(*senCount) = inSenCount;
	(*totalCount) = inTotalCount;
}

int calculateGreatestPossRemovalCount(equivalenceClass *eqClass, configure *conf)
{
	int returnValue;

	int senCount;
	int totalCount;

	calculateSensitiveCount(eqClass, conf, &senCount, &totalCount);

	// flooring
	returnValue = (int) (totalCount - senCount/conf->alpha);

	if (returnValue < 0)
	{
		returnValue = 0;
	}

	return returnValue;
}


int main()
{
	char *configFilename = "conf.txt";

	configure *config;
	data *dataSet;
	generalizedAllTable *genAllTable;

	config = readConfig(configFilename);
	dataSet = readData(config);
	genAllTable = readGen(config);

	//void progressiveMain(data *dataSet, configure *conf, generalizedAllTable *genAllTable)
	//progressiveMain(dataSet, config, genAllTable);

	//hierachicalMain(dataSet, config, genAllTable);
	randomMain(dataSet, config, genAllTable);

	//testQsort();
}
